package com.sd.business.service.in.impl;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sd.business.entity.in.dto.InOutStorageDto;
import com.sd.business.entity.in.dto.InOutStorageSelectDto;
import com.sd.business.entity.in.po.InOutStorage;
import com.sd.business.entity.in.vo.InOutStorageVo;
import com.sd.business.mapper.in.InOutStorageMapper;
import com.sd.business.service.in.InOutStorageService;
import com.sd.framework.util.Assert;
import com.sd.framework.util.sql.Sql;
import org.springframework.stereotype.Service;


/**
 * <p>
 * 出入库 服务实现类
 * </p>
 *
 * @author
 * @since 2023-12-11
 */
@Service
public class InOutStorageServiceImpl extends ServiceImpl<InOutStorageMapper, InOutStorage> implements InOutStorageService {

    @Override
    public Page<InOutStorageVo> getPage(InOutStorageSelectDto dto) {

        Page<InOutStorageVo> page = Sql.create(InOutStorageVo.class)
                .selectAll(InOutStorage.class)
                .from(InOutStorage.class)
                .orderByDesc(InOutStorage::getId)
                .page(dto);

        return page;
    }

    @Override
    public InOutStorageVo detail(Long id) {

        InOutStorageVo vo = Sql.create(InOutStorageVo.class)
                .selectAll(InOutStorage.class)
                .from(InOutStorage.class)
                .eq(InOutStorage::getId, id)
                .one();

        Assert.notNull(vo, "未知数据");

        return vo;
    }

    @Override
    public void add(InOutStorageDto dto) {
        save(dto);
    }

    @Override
    public void edit(InOutStorageDto dto) {
        updateById(dto);
    }

    @Override
    public void delete(Long id) {
        removeById(id);
    }

}
